/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-16 19:40
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============

struct rem {
  pair<int,int> nr;
  int p;
};
bool cmp(rem &a, rem &b){ return a.nr < b.nr; }
struct suffix_array{
  string s;
  int N, LG;
  vector<vector<int>> p;
  vector<int> array, rank;
  suffix_array(const string &os){
    s = os, N = size(s), LG = __bit_width(N) + 1;
    p.emplace_back(begin(s), end(s));
    rem L[N];
    for (int stp = 1; stp < LG; stp++){
      int cnt = 1 << (stp - 1);
      for (int i = 0; i < N; i++)
        L[i] = {{p[stp - 1][i],
          i + cnt < N ? p[stp-1][i+cnt] : -1}, i};
      sort(L, L + N, cmp);
      p.emplace_back(N); // 0-init vector in-place
      for (int i = 0; i < N; i++)
        p[stp][L[i].p] = i>0 && L[i].nr==L[i-1].nr
            ? p[stp][L[i-1].p] : i;
    }
    rank = vector<int>(p[LG - 1]);
    array = vector<int>(N);
    for(int i = 0; i < N; i++)
      array[rank[i]] = i;
  }
  int lcp(int i, int j){
    int res = 0;
    for(int k = LG - 1; 0 <= k && i<N && j<N; k--)
      if(p[k][i] == p[k][j])
        res += 1 << k, i += 1 << k, j += 1 << k;
    return res;
  }
  int compare(int i, int j, int l){
    if(l == 0) return p[0][i] == p[0][j];
    int k = __bit_width(l) - 1;
    pair<int,int> pi(p[k][i], p[k][i+l-(1<<k)]);
    pair<int,int> pj(p[k][j], p[k][j+l-(1<<k)]);
    return pi == pj ? 0 : pi < pj ? -1 : 1;
  }
  typedef vector<int>::iterator vit;
  vit find(string pre){
    auto p = [this, pre](int pos){
      return s.substr(pos) < pre;
    };
    return ranges::partition_point(array, p);
  }
  pair<vit, vit> range(string pre){
    auto it1 = find(pre);
    pre[ssize(pre) - 1] += 1;
    auto it2 = find(pre);
    return {it1, it2};
  }


  vit find_hint(char pre, vit start, vit end, int depth){
    /* cerr << "Lenght of pre " << size(pre) << endl; */
    auto p = [this, pre, depth](int pos){
      return s[pos + depth] < pre;
    };
    return partition_point(start, end, p);
  }

  pair<vit, vit> range_hint(char pre, vit start, vit end, int depth = 0){
    auto it1 = find_hint(pre, start, end, depth);
    pre += 1;
    auto it2 = find_hint(pre, start, end, depth);
    return {it1, it2};
  }
};


struct sparse_table{
  int N, LG;
  vector<vector<ll>> sp;
  sparse_table(vector<ll> a){
    N = size(a), LG = __bit_width(N);
    sp.assign(LG, vector<ll>(N)), sp[0] = a;
    for(int k = 0; k < LG - 1; k++)
      for(int i = 0; i + (2 << k) <= N; i++){
        ll t1 = sp[k][i];
        ll t2 = sp[k][i + (1 << (k))];
        sp[k + 1][i] = min(t1, t2);
      }
  }
  ll get(int l, int r){
    int k = __bit_width(r - l + 1) - 1;
    return min(sp[k][l], sp[k][r-(1<<k)+1]);
  }
};

void test_ranges(string text){
    // testing
    suffix_array tsa(text);
    for(auto p: {"#", "A", "BA", "BCA", "BCB", "BCC", "C", "D"}){
        auto [it1, it2] = tsa.range(p);
        int num = it2 - it1;
        cerr << p << " matches " << num << " positions."; // << endl;
        if(num > 0){
            // because num > 0 => only it2 can be tsa.array.end()
            int v = *it1, w = it2 == tsa.array.end() ? tsa.N : *it2;
            cerr << " They range from " << tsa.s.substr(v) << " to " << tsa.s.substr(w);
        }
        cerr << endl;
    }
}

string s, rs;
int N, M;

template<typename T>
void show(string s, vector<T> v){
    cerr << s << endl;
    for(auto e: v)
        cerr << e << " ";
    cerr << endl;
}

void show_sa(suffix_array sa, string s){
    for(int i = 0; i < ssize(sa.array); i++)
        cerr << s.substr(sa.array[i]) << " ";
    cerr << endl;
}

// idea:
// 1. calculate suffix array of both s and reverse(s)
// 2. calculate a RMQ/Sparsetable for both arrays
// (e.g. for two pos i and k in the suffix array
//  find the smallest starting index for all 
//  suffices between array[i, k].)
// 3. for each word, for each character find 
// start and end position in suffix array
// (and reversed versions of course)
// and use the RMQ to find the smallest index
// at which a prefix of size i starts.
// 4. Look through f and b to check whether
// this word is beautiful
//
// Analysis:
// 1. O(2 n log n)
// 2. O(2 n log n)
// 3. O(2 * 100 * 1000 * 1000 * log n)
// 4. O(100 * 1000)


void solve(){
    // Code goes here ...
    int cnt = 0;
    cin >> s >> M;
    N = ssize(s);
    rs = string(rbegin(s), rend(s));

    suffix_array sa(s), rsa(rs);
    /* show_sa(sa, s); */
    /* show_sa(rsa, rs); */

    vector<ll> t1(begin(sa.array), end(sa.array));
    vector<ll> t2(begin(rsa.array), end(rsa.array));
    sparse_table stf(t1), stb(t2);

    /* test_ranges("ABCBABA"); */

    R(i, M){
        string word, rword;
        cin >> word;
        rword = string(rbegin(word), rend(word));

        vector<int> f{N}, b{N};
        typedef vector<int>::iterator vit;
        vit f1 = sa.array.begin(), f2 = sa.array.end();
        vit b1 = rsa.array.begin(), b2 = rsa.array.end();
        for(int i = 0; i < ssize(word); i++){
            // front search
            tie(f1, f2) = sa.range_hint(word[i], f1, f2, i);
            if (f2 - f1 <= 0) {
                f.push_back(N);
            }
            else {
                int fl = f1 - sa.array.begin(), fr = f2 - 1 - sa.array.begin();
                f.push_back(stf.get(fl, fr));
            }
            // back search
            tie(b1, b2) = rsa.range_hint(rword[i], b1, b2, i);
            if (b2 - b1 <= 0) {
                b.push_back(N);
            }
            else {
                int bl = b1 - rsa.array.begin(), br = b2 - 1 - rsa.array.begin();
                b.push_back(stb.get(bl, br));
            }
        }
        /* show("f", f); */
        /* show("b", b); */

        for(int i = 1; i < ssize(word); i++){
            if(N >= ssize(word) + f[i] + b[ssize(word) - i]){
                /* cerr << "Found: " << word << endl; */
                /* fprintf(stderr, "%d at %d and %lld at %d (backwards)\n", i, f[i], ssize(word) - i, b[ssize(word) - i]); */
                cnt++;
                break;
            }
        }
    }

    cout << cnt << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    /* cin >> T; */
    while(T--)
        solve();

    return 0;
}
        
